BUSYBOX(1)

NAME
BusyBox - The Swiss Army Knife of Embedded Linux

SYNTAX
 busybox <applet> [arguments...]  # or

 <applet> [arguments...]          # if symlinked

DESCRIPTION
BusyBox combines tiny versions of many common UNIX utilities into a single small executable. It provides minimalist replacements for most of the utilities you usually find in GNU coreutils, util-linux, etc. The utilities in BusyBox generally have fewer options than their full-featured GNU cousins; however, the options that are included provide the expected functionality and behave very much like their GNU counterparts.

BusyBox has been written with size-optimization and limited resources in mind. It is also extremely modular so you can easily include or exclude commands (or features) at compile time. This makes it easy to customize your embedded systems. To create a working system, just add /dev, /etc, and a Linux kernel. BusyBox provides a fairly complete POSIX environment for any small or embedded system.

BusyBox is extremely configurable. This allows you to include only the components you need, thereby reducing binary size. Run 'make config' or 'make menuconfig' to select the functionality that you wish to enable. Then run 'make' to compile BusyBox using your configuration.

After the compile has finished, you should use 'make install' to install BusyBox. This will install the 'bin/busybox' binary, in the target directory specified by CONFIG_PREFIX. CONFIG_PREFIX can be set when configuring BusyBox, or you can specify an alternative location at install time (i.e., with a command line like 'make CONFIG_PREFIX=/tmp/foo install'). If you enabled any applet installation scheme (either as symlinks or hardlinks), these will also be installed in the location pointed to by CONFIG_PREFIX.

USAGE
BusyBox is a multi-call binary. A multi-call binary is an executable program that performs the same job as more than one utility program. That means there is just a single BusyBox binary, but that single binary acts like a large number of utilities. This allows BusyBox to be smaller since all the built-in utility programs (we call them applets) can share code for many common operations.

You can also invoke BusyBox by issuing a command as an argument on the command line. For example, entering

        /bin/busybox ls

will also cause BusyBox to behave as 'ls'.

Of course, adding '/bin/busybox' into every command would be painful. So most people will invoke BusyBox using links to the BusyBox binary.

For example, entering

        ln -s /bin/busybox ls
        ./ls

will cause BusyBox to behave as 'ls' (if the 'ls' command has been compiled into BusyBox). Generally speaking, you should never need to make all these links yourself, as the BusyBox build system will do this for you when you run the 'make install' command.

If you invoke BusyBox with no arguments, it will provide you with a list of the applets that have been compiled into your BusyBox binary.

COMMON OPTIONS
Most BusyBox applets support the --help argument to provide a terse runtime description of their behavior. If the CONFIG_FEATURE_VERBOSE_USAGE option has been enabled, more detailed usage information will also be available.

COMMANDS
Currently available applets include:

        [, [[, acpid, adjtimex, ar, arch, arp, arping, ash, awk, basename,
        bc, blkdiscard, blockdev, brctl, bunzip2, bzcat, bzip2, cal, cat,
        chgrp, chmod, chown, chroot, chvt, clear, cmp, cp, cpio, cttyhack,
        cut, date, dc, dd, deallocvt, depmod, devmem, df, diff, dirname,
        dmesg, dnsdomainname, dos2unix, du, dumpkmap, dumpleases, echo,
        egrep, env, expand, expr, factor, fallocate, false, fatattr, fgrep,
        find, fold, free, freeramdisk, fsfreeze, fstrim, ftpget, ftpput,
        getopt, getty, grep, groups, gunzip, gzip, halt, head, hexdump,
        hostid, hostname, httpd, hwclock, i2cdetect, i2cdump, i2cget,
        i2cset, id, ifconfig, ifdown, ifup, init, insmod, ionice, ip,
        ipcalc, ipneigh, kill, killall, klogd, last, less, link, linux32,
        linux64, linuxrc, ln, loadfont, loadkmap, logger, login, logname,
        logread, losetup, ls, lsmod, lsscsi, lzcat, lzma, lzop, md5sum,
        mdev, microcom, mkdir, mkdosfs, mke2fs, mkfifo, mknod, mkpasswd,
        mkswap, mktemp, modinfo, modprobe, more, mount, mt, mv, nameif, nc,
        netstat, nl, nologin, nproc, nsenter, nslookup, nuke, od, openvt,
        partprobe, paste, patch, pidof, ping, ping6, pivot_root, poweroff,
        printf, ps, pwd, rdate, readlink, realpath, reboot, renice, reset,
        resume, rev, rm, rmdir, rmmod, route, rpm, rpm2cpio, run-init,
        run-parts, sed, seq, setkeycodes, setpriv, setsid, sh, sha1sum,
        sha256sum, sha512sum, shred, shuf, sleep, sort, ssl_client,
        start-stop-daemon, stat, strings, stty, svc, svok, swapoff, swapon,
        switch_root, sync, sysctl, syslogd, tac, tail, tar, taskset, tee,
        telnet, test, tftp, time, timeout, top, touch, tr, traceroute,
        traceroute6, true, truncate, tty, ubirename, udhcpc, udhcpd, uevent,
        umount, uname, uncompress, unexpand, uniq, unix2dos, unlink, unlzma,
        unshare, unxz, unzip, uptime, usleep, uudecode, uuencode, vconfig,
        vi, w, watch, watchdog, wc, wget, which, who, whoami, xargs, xxd,
        xz, xzcat, yes, zcat

COMMAND DESCRIPTIONS

acpid
    acpid [-df] [-c CONFDIR] [-l LOGFILE] [-a ACTIONFILE] [-M MAPFILE] [-e PROC_EVENT_FILE] [-p PIDFILE]

    Listen to ACPI events and spawn specific helpers on event arrival

            -d      Log to stderr, not log file (implies -f)
            -f      Run in foreground
            -c DIR  Config directory [/etc/acpi]
            -e FILE /proc event file [/proc/acpi/event]
            -l FILE Log file [/var/log/acpid.log]
            -p FILE Pid file [/var/run/acpid.pid]
            -a FILE Action file [/etc/acpid.conf]
            -M FILE Map file [/etc/acpi.map]

    Accept and ignore compatibility options -g -m -s -S -v

adjtimex
    adjtimex [-q] [-o OFF] [-f FREQ] [-p TCONST] [-t TICK]

    Read or set kernel time variables. See adjtimex(2)

            -q      Quiet
            -o OFF  Time offset, microseconds
            -f FREQ Frequency adjust, integer kernel units (65536 is 1ppm)
            -t TICK Microseconds per tick, usually 10000
                    (positive -t or -f values make clock run faster)
            -p TCONST

ar  ar [-o] [-v] [-p] [-t] [-x] ARCHIVE FILES

    Extract or list FILES from an ar archive

            -o      Preserve original dates
            -p      Extract to stdout
            -t      List
            -x      Extract
            -v      Verbose

arch
    arch

    Print system architecture

arp arp
    [-vn]    [-H HWTYPE] [-i IF] -a [HOSTNAME]
    [-v]        [-i IF] -d HOSTNAME [pub]
    [-v]    [-H HWTYPE] [-i IF] -s HOSTNAME HWADDR [temp]
    [-v]    [-H HWTYPE] [-i IF] -s HOSTNAME HWADDR [netmask MASK] pub
    [-v]    [-H HWTYPE] [-i IF] -Ds HOSTNAME IFACE [netmask MASK] pub

    Manipulate ARP cache

            -a              Display (all) hosts
            -d              Delete ARP entry
            -s              Set new entry
            -v              Verbose
            -n              Don't resolve names
            -i IF           Network interface
            -D              Read HWADDR from IFACE
            -A,-p AF        Protocol family
            -H HWTYPE       Hardware address type

arping
    arping [-fqbDUA] [-c CNT] [-w TIMEOUT] [-I IFACE] [-s SRC_IP] DST_IP

    Send ARP requests/replies

            -f              Quit on first ARP reply
            -q              Quiet
            -b              Keep broadcasting, don't go unicast
            -D              Exit with 1 if DST_IP replies
            -U              Unsolicited ARP mode, update your neighbors
            -A              ARP answer mode, update your neighbors
            -c N            Stop after sending N ARP requests
            -w TIMEOUT      Seconds to wait for ARP reply
            -I IFACE        Interface to use (default eth0)
            -s SRC_IP       Sender IP address
            DST_IP          Target IP address

ash ash [-/+OPTIONS] [-/+o OPT]... [-c 'SCRIPT' [ARG0 [ARGS]] / FILE [ARGS] / -s [ARGS]]

    Unix shell interpreter

awk awk [OPTIONS] [AWK_PROGRAM] [FILE]...

            -v VAR=VAL      Set variable
            -F SEP          Use SEP as field separator
            -f FILE         Read program from FILE
            -e AWK_PROGRAM

basename
    basename FILE [SUFFIX]

    Strip directory path and .SUFFIX from FILE

bc  bc [-sqlw] FILE...

    Arbitrary precision calculator

            -q      Quiet
            -l      Load standard math library
            -s      Be POSIX compatible
            -w      Warn if extensions are used

    $BC_LINE_LENGTH changes output width

blkdiscard
    blkdiscard [-o OFS] [-l LEN] [-s] DEVICE

    Discard sectors on DEVICE

            -o OFS  Byte offset into device
            -l LEN  Number of bytes to discard
            -s      Perform a secure discard

blockdev
    blockdev OPTION BLOCKDEV

            --setro         Set ro
            --setrw         Set rw
            --getro         Get ro
            --getss         Get sector size
            --getbsz        Get block size
            --setbsz BYTES  Set block size
            --getsz         Get device size in 512-byte sectors
            --getsize64     Get device size in bytes
            --flushbufs     Flush buffers
            --rereadpt      Reread partition table

brctl
    brctl COMMAND [BRIDGE [INTERFACE]]

    Manage ethernet bridges

    Commands:

            addbr BRIDGE            Create BRIDGE
            delbr BRIDGE            Delete BRIDGE
            addif BRIDGE IFACE      Add IFACE to BRIDGE
            delif BRIDGE IFACE      Delete IFACE from BRIDGE

bunzip2
    bunzip2 [-cfk] [FILE]...

    Decompress FILEs (or stdin)

            -c      Write to stdout
            -f      Force
            -k      Keep input files

bzcat
    bzcat [FILE]...

    Decompress to stdout

bzip2
    bzip2 [OPTIONS] [FILE]...

    Compress FILEs (or stdin) with bzip2 algorithm

            -1..9   Compression level
            -d      Decompress
            -t      Test file integrity
            -c      Write to stdout
            -f      Force
            -k      Keep input files

cal cal [-jy] [[MONTH] YEAR]

    Display a calendar

            -j      Use julian dates
            -y      Display the entire year

cat cat [-nbvteA] [FILE]...

    Print FILEs to stdout

            -n      Number output lines
            -b      Number nonempty lines
            -v      Show nonprinting characters as ^x or M-x
            -t      ...and tabs as ^I
            -e      ...and end lines with $
            -A      Same as -vte

chgrp
    chgrp [-RhLHPcvf]... GROUP FILE...

    Change the group membership of each FILE to GROUP

            -R      Recurse
            -h      Affect symlinks instead of symlink targets
            -L      Traverse all symlinks to directories
            -H      Traverse symlinks on command line only
            -P      Don't traverse symlinks (default)
            -c      List changed files
            -v      Verbose
            -f      Hide errors

chmod
    chmod [-Rcvf] MODE[,MODE]... FILE...

    Each MODE is one or more of the letters ugoa, one of the symbols +-= and one or more of the letters rwxst

            -R      Recurse
            -c      List changed files
            -v      List all files
            -f      Hide errors

chown
    chown [-RhLHPcvf]... USER[:[GRP]] FILE...

    Change the owner and/or group of each FILE to USER and/or GRP

            -R      Recurse
            -h      Affect symlinks instead of symlink targets
            -L      Traverse all symlinks to directories
            -H      Traverse symlinks on command line only
            -P      Don't traverse symlinks (default)
            -c      List changed files
            -v      List all files
            -f      Hide errors

chroot
    chroot NEWROOT [PROG ARGS]

    Run PROG with root directory set to NEWROOT

chvt
    chvt N

    Change the foreground virtual terminal to /dev/ttyN

clear
    clear

    Clear screen

cmp cmp [-l] [-s] FILE1 [FILE2 [SKIP1 [SKIP2]]]

    Compare FILE1 with FILE2 (or stdin)

            -l      Write the byte numbers (decimal) and values (octal)
                    for all differing bytes
            -s      Quiet

cp  cp [OPTIONS] SOURCE... DEST

    Copy SOURCE(s) to DEST

            -a      Same as -dpR
            -R,-r   Recurse
            -d,-P   Preserve symlinks (default if -R)
            -L      Follow all symlinks
            -H      Follow symlinks on command line
            -p      Preserve file attributes if possible
            -f      Overwrite
            -i      Prompt before overwrite
            -l,-s   Create (sym)links
            -T      Treat DEST as a normal file
            -u      Copy only newer files

cpio
    cpio [-dmvu] [-F FILE] [-R USER[:GRP]] [-H newc] [-tio] [EXTR_FILE]...

    Extract (-i) or list (-t) files from a cpio archive, or take file list from stdin and create an archive (-o)

    Main operation mode:

            -t      List
            -i      Extract EXTR_FILEs (or all)
            -o      Create (requires -H newc)
    Options:

            -H newc Archive format
            -d      Make leading directories
            -m      Preserve mtime
            -v      Verbose
            -u      Overwrite
            -F FILE Input (-t,-i,-p) or output (-o) file
            -R USER[:GRP]   Set owner of created files
            -L      Dereference symlinks
            -0      Input is separated by NULs

cttyhack
    cttyhack [PROG ARGS]

    Give PROG a controlling tty if possible. Example for /etc/inittab (for busybox init):
        ::respawn:/bin/cttyhack /bin/sh Giving controlling tty to shell running with PID 1:
        $ exec cttyhack sh Starting interactive shell from boot shell script:

            setsid cttyhack sh

cut cut [OPTIONS] [FILE]...

    Print selected fields from each input FILE to stdout

            -b LIST Output only bytes from LIST
            -c LIST Output only characters from LIST
            -d CHAR Use CHAR instead of tab as the field delimiter
            -s      Output only the lines containing delimiter
            -f N    Print only these fields
            -n      Ignored

date
    date [OPTIONS] [+FMT] [TIME]

    Display time (using +FMT), or set time

            [-s,--set] TIME Set time to TIME
            -u,--utc        Work in UTC (don't convert to local time)
            -R,--rfc-2822   Output RFC-2822 compliant date string
            -I[SPEC]        Output ISO-8601 compliant date string
                            SPEC='date' (default) for date only,
                            'hours', 'minutes', or 'seconds' for date and
                            time to the indicated precision
            -r,--reference FILE     Display last modification time of FILE
            -d,--date TIME  Display TIME, not 'now'
            -D FMT          Use FMT for -d TIME conversion

    Recognized TIME formats:

            hh:mm[:ss]
            [YYYY.]MM.DD-hh:mm[:ss]
            YYYY-MM-DD hh:mm[:ss]
            [[[[[YY]YY]MM]DD]hh]mm[.ss]
            'date TIME' form accepts MMDDhhmm[[YY]YY][.ss] instead

dc  dc [-x] [-eSCRIPT]... [-fFILE]... [FILE]...

    Tiny RPN calculator. Operations: +, -, *, /, %, ~, ^, |, p - print top of the stack without popping f - print entire stack k - pop the value and set the precision i - pop the value and set input radix o - pop the value and set output radix Examples: dc -e'2 2 + p' -> 4, dc -e'8 8 * 2 2 + / p' -> 16

dd  dd [if=FILE] [of=FILE] [ibs=N obs=N/bs=N] [count=N] [skip=N] [seek=N]
        [conv=notrunc|noerror|sync|fsync]
        [iflag=skip_bytes|fullblock] [oflag=seek_bytes]

    Copy a file with converting and formatting

            if=FILE         Read from FILE instead of stdin
            of=FILE         Write to FILE instead of stdout
            bs=N            Read and write N bytes at a time
            ibs=N           Read N bytes at a time
            obs=N           Write N bytes at a time
            count=N         Copy only N input blocks
            skip=N          Skip N input blocks
            seek=N          Skip N output blocks
            conv=notrunc    Don't truncate output file
            conv=noerror    Continue after read errors
            conv=sync       Pad blocks with zeros
            conv=fsync      Physically write data out before finishing
            conv=swab       Swap every pair of bytes
            iflag=skip_bytes        skip=N is in bytes
            iflag=fullblock Read full blocks
            oflag=seek_bytes        seek=N is in bytes
            status=noxfer   Suppress rate output
            status=none     Suppress all output

    N may be suffixed by c (1), w (2), b (512), kB (1000), k (1024), MB, M, GB, G

deallocvt
    deallocvt [N]

    Deallocate unused virtual terminal /dev/ttyN

depmod
    depmod [-n] [-b BASE] [VERSION] [MODFILES]...

    Generate modules.dep, alias, and symbols files

            -b BASE Use BASE/lib/modules/VERSION
            -n      Dry run: print files to stdout

devmem
    devmem ADDRESS [WIDTH [VALUE]]

    Read/write from physical address

            ADDRESS Address to act upon
            WIDTH   Width (8/16/...)
            VALUE   Data to be written

df  df [-PkmhTai] [-B SIZE] [FILESYSTEM]...

    Print filesystem usage statistics

            -P      POSIX output format
            -k      1024-byte blocks (default)
            -m      1M-byte blocks
            -h      Human readable (e.g. 1K 243M 2G)
            -T      Print filesystem type
            -a      Show all filesystems
            -i      Inodes
            -B SIZE Blocksize

diff
    diff [-abBdiNqrTstw] [-L LABEL] [-S FILE] [-U LINES] FILE1 FILE2

    Compare files line by line and output the differences between them. This implementation supports unified diffs only.

            -a      Treat all files as text
            -b      Ignore changes in the amount of whitespace
            -B      Ignore changes whose lines are all blank
            -d      Try hard to find a smaller set of changes
            -i      Ignore case differences
            -L      Use LABEL instead of the filename in the unified header
            -N      Treat absent files as empty
            -q      Output only whether files differ
            -r      Recurse
            -S      Start with FILE when comparing directories
            -T      Make tabs line up by prefixing a tab when necessary
            -s      Report when two files are the same
            -t      Expand tabs to spaces in output
            -U      Output LINES lines of context
            -w      Ignore all whitespace

dirname
    dirname FILENAME

    Strip non-directory suffix from FILENAME

dmesg
    dmesg [-c] [-n LEVEL] [-s SIZE]

    Print or control the kernel ring buffer

            -c              Clear ring buffer after printing
            -n LEVEL        Set console logging level
            -s SIZE         Buffer size
            -r              Print raw message buffer

dos2unix
    dos2unix [-ud] [FILE]

    Convert FILE in-place from DOS to Unix format. When no file is given, use stdin/stdout.

            -u      dos2unix
            -d      unix2dos

du  du [-aHLdclsxhmk] [FILE]...

    Summarize disk space used for each FILE and/or directory

            -a      Show file sizes too
            -L      Follow all symlinks
            -H      Follow symlinks on command line
            -d N    Limit output to directories (and files with -a) of depth < N
            -c      Show grand total
            -l      Count sizes many times if hard linked
            -s      Display only a total for each argument
            -x      Skip directories on different filesystems
            -h      Sizes in human readable format (e.g., 1K 243M 2G)
            -m      Sizes in megabytes
            -k      Sizes in kilobytes (default)

dumpkmap
    dumpkmap > keymap

    Print a binary keyboard translation table to stdout

dumpleases
    dumpleases [-r|-a] [-d] [-f LEASEFILE]

    Display DHCP leases granted by udhcpd

            -f,--file FILE  Lease file
            -r,--remaining  Show remaining time
            -a,--absolute   Show expiration time
            -d,--decimal    Show time in seconds

echo
    echo [-neE] [ARG]...

    Print the specified ARGs to stdout

            -n      Suppress trailing newline
            -e      Interpret backslash escapes (i.e., \t=tab)
            -E      Don't interpret backslash escapes (default)

env env [-iu] [-] [name=value]... [PROG ARGS]

    Print the current environment or run PROG after setting up the specified environment

            -, -i   Start with an empty environment
            -u      Remove variable from the environment

expand
    expand [-i] [-t N] [FILE]...

    Convert tabs to spaces, writing to stdout

            -i      Don't convert tabs after non blanks
            -t      Tabstops every N chars

expr
    expr EXPRESSION

    Print the value of EXPRESSION to stdout

    EXPRESSION may be:

            ARG1 | ARG2     ARG1 if it is neither null nor 0, otherwise ARG2
            ARG1 & ARG2     ARG1 if neither argument is null or 0, otherwise 0
            ARG1 < ARG2     1 if ARG1 is less than ARG2, else 0. Similarly:
            ARG1 <= ARG2
            ARG1 = ARG2
            ARG1 != ARG2
            ARG1 >= ARG2
            ARG1 > ARG2
            ARG1 + ARG2     Sum of ARG1 and ARG2. Similarly:
            ARG1 - ARG2
            ARG1 * ARG2
            ARG1 / ARG2
            ARG1 % ARG2
            STRING : REGEXP         Anchored pattern match of REGEXP in STRING
            match STRING REGEXP     Same as STRING : REGEXP
            substr STRING POS LENGTH Substring of STRING, POS counted from 1
            index STRING CHARS      Index in STRING where any CHARS is found, or 0
            length STRING           Length of STRING
            quote TOKEN             Interpret TOKEN as a string, even if
                                    it is a keyword like 'match' or an
                                    operator like '/'
            (EXPRESSION)            Value of EXPRESSION

    Beware that many operators need to be escaped or quoted for shells. Comparisons are arithmetic if both ARGs are numbers, else lexicographical. Pattern matches return the string matched between \( and \) or null; if \( and \) are not used, they return the number of characters matched or 0.

factor
    factor [NUMBER]...

    Print prime factors

fallocate
    fallocate [-o OFS] -l LEN FILE

    Preallocate space for FILE

            -o OFS  Offset of range
            -l LEN  Length of range

fatattr
    fatattr [-+rhsvda] FILE...

    Change file attributes on FAT filesystem

            -       Clear attributes
            +       Set attributes
            r       Read only
            h       Hidden
            s       System
            v       Volume label
            d       Directory
            a       Archive

find
    find [-HL] [PATH]... [OPTIONS] [ACTIONS]

    Search for files and perform actions on them. First failed action stops processing of current file. Defaults: PATH is current directory, action is '-print'

            -L,-follow      Follow symlinks
            -H              ...on command line only
            -xdev           Don't descend directories on other filesystems
            -maxdepth N     Descend at most N levels. -maxdepth 0 applies
                            actions to command line arguments only
            -mindepth N     Don't act on first N levels
            -depth          Act on directory *after* traversing it

    Actions:

            ( ACTIONS )     Group actions for -o / -a
            ! ACT           Invert ACT's success/failure
            ACT1 [-a] ACT2  If ACT1 fails, stop, else do ACT2
            ACT1 -o ACT2    If ACT1 succeeds, stop, else do ACT2
                            Note: -a has higher priority than -o
            -name PATTERN   Match file name (w/o directory name) to PATTERN
            -iname PATTERN  Case insensitive -name
            -path PATTERN   Match path to PATTERN
            -ipath PATTERN  Case insensitive -path
            -regex PATTERN  Match path to regex PATTERN
            -type X         File type is X (one of: f,d,l,b,c,s,p)
            -executable     File is executable
            -perm MASK      At least one mask bit (+MASK), all bits (-MASK),
                            or exactly MASK bits are set in file's mode
            -mtime DAYS     mtime is greater than (+N), less than (-N),
                            or exactly N days in the past
            -mmin MINS      mtime is greater than (+N), less than (-N),
                            or exactly N minutes in the past
            -newer FILE     mtime is more recent than FILE's
            -inum N         File has inode number N
            -user NAME/ID   File is owned by given user
            -group NAME/ID  File is owned by given group
            -size N[bck]    File size is N (c:bytes,k:kbytes,b:512 bytes(def.))
                            +/-N: file size is bigger/smaller than N
            -links N        Number of links is greater than (+N), less than (-N),
                            or exactly N
            -prune          If current file is directory, don't descend into it
    If none of the following actions is specified, -print is assumed
            -print          Print file name
            -print0         Print file name, NUL terminated
            -exec CMD ARG ; Run CMD with all instances of {} replaced by
                            file name. Fails if CMD exits with nonzero
            -exec CMD ARG + Run CMD with {} replaced by list of file names
            -quit           Exit

fold
    fold [-bs] [-w WIDTH] [FILE]...

    Wrap input lines in each FILE (or stdin), writing to stdout

            -b      Count bytes rather than columns
            -s      Break at spaces
            -w      Use WIDTH columns instead of 80

free
    free [-b/k/m/g]

    Display the amount of free and used system memory

freeramdisk
    freeramdisk DEVICE

    Free all memory used by the specified ramdisk

fsfreeze
    fsfreeze --[un]freeze MOUNTPOINT

    Flush and halt writes to MOUNTPOINT

fstrim
    fstrim [OPTIONS] MOUNTPOINT

            -o,--offset OFFSET      Offset in bytes to discard from
            -l,--length LEN         Bytes to discard
            -m,--minimum MIN        Minimum extent length
            -v,--verbose            Print number of discarded bytes

ftpget
    ftpget [OPTIONS] HOST [LOCAL_FILE] REMOTE_FILE

    Download a file via FTP

            -c      Continue previous transfer
            -v      Verbose
            -u USER Username
            -p PASS Password
            -P NUM  Port

ftpput
    ftpput [OPTIONS] HOST [REMOTE_FILE] LOCAL_FILE

    Upload a file to a FTP server

            -v      Verbose
            -u USER Username
            -p PASS Password
            -P NUM  Port number

getopt
    getopt [OPTIONS] [--] OPTSTRING PARAMS

            -a              Allow long options starting with single -
            -l LOPT[,...]   Long options to recognize
            -n PROGNAME     The name under which errors are reported
            -o OPTSTRING    Short options to recognize
            -q              No error messages on unrecognized options
            -Q              No normal output
            -s SHELL        Set shell quoting conventions
            -T              Version test (exits with 4)
            -u              Don't quote output

    Example:

    O=`getopt -l bb: -- ab:c:: "$@"` || exit 1 eval set -- "$O" while true; do
        case "$1" in
        -a)    echo A; shift;;
        -b|--bb) echo "B:'$2'"; shift 2;;
        -c)    case "$2" in
        "")    echo C; shift 2;;
        *)    echo "C:'$2'"; shift 2;;
            esac;;
        --)    shift; break;;
        *)    echo Error; exit 1;;
        esac done

getty
    getty [OPTIONS] BAUD_RATE[,BAUD_RATE]... TTY [TERMTYPE]

    Open TTY, prompt for login name, then invoke /bin/login

            -h              Enable hardware RTS/CTS flow control
            -L              Set CLOCAL (ignore Carrier Detect state)
            -m              Get baud rate from modem's CONNECT status message
            -n              Don't prompt for login name
            -w              Wait for CR or LF before sending /etc/issue
            -i              Don't display /etc/issue
            -f ISSUE_FILE   Display ISSUE_FILE instead of /etc/issue
            -l LOGIN        Invoke LOGIN instead of /bin/login
            -t SEC          Terminate after SEC if no login name is read
            -I INITSTR      Send INITSTR before anything else
            -H HOST         Log HOST into the utmp file as the hostname

    BAUD_RATE of 0 leaves it unchanged

grep
    grep [-HhnlLoqvsriwFEz] [-m N] [-A/B/C N] PATTERN/-e PATTERN.../-f FILE [FILE]...

    Search for PATTERN in FILEs (or stdin)

            -H      Add 'filename:' prefix
            -h      Do not add 'filename:' prefix
            -n      Add 'line_no:' prefix
            -l      Show only names of files that match
            -L      Show only names of files that don't match
            -c      Show only count of matching lines
            -o      Show only the matching part of line
            -q      Quiet. Return 0 if PATTERN is found, 1 otherwise
            -v      Select non-matching lines
            -s      Suppress open and read errors
            -r      Recurse
            -i      Ignore case
            -w      Match whole words only
            -x      Match whole lines only
            -F      PATTERN is a literal (not regexp)
            -E      PATTERN is an extended regexp
            -z      Input is NUL terminated
            -m N    Match up to N times per file
            -A N    Print N lines of trailing context
            -B N    Print N lines of leading context
            -C N    Same as '-A N -B N'
            -e PTRN Pattern to match
            -f FILE Read pattern from file

groups
    groups [USER]

    Print the group memberships of USER or for the current process

gunzip
    gunzip [-cfkt] [FILE]...

    Decompress FILEs (or stdin)

            -c      Write to stdout
            -f      Force
            -k      Keep input files
            -t      Test file integrity

gzip
    gzip [-cfkdt] [FILE]...

    Compress FILEs (or stdin)

            -d      Decompress
            -t      Test file integrity
            -c      Write to stdout
            -f      Force
            -k      Keep input files

halt
    halt [-d DELAY] [-n] [-f] [-w]

    Halt the system

            -d SEC  Delay interval
            -n      Do not sync
            -f      Force (don't go through init)
            -w      Only write a wtmp record

head
    head [OPTIONS] [FILE]...

    Print first 10 lines of each FILE (or stdin) to stdout. With more than one FILE, precede each with a filename header.

            -n N[kbm]       Print first N lines
            -n -N[kbm]      Print all except N last lines
            -c [-]N[kbm]    Print first N bytes
            -q              Never print headers
            -v              Always print headers

    N may be suffixed by k (x1024), b (x512), or m (x1024^2).

hexdump
    hexdump [-bcCdefnosvx] [FILE]...

    Display FILEs (or stdin) in a user specified format

            -b              1-byte octal display
            -c              1-byte character display
            -d              2-byte decimal display
            -o              2-byte octal display
            -x              2-byte hex display
            -C              hex+ASCII 16 bytes per line
            -v              Show all (no dup folding)
            -e FORMAT_STR   Example: '16/1 "%02x|""\n"'
            -f FORMAT_FILE
            -n LENGTH       Show only first LENGTH bytes
            -s OFFSET       Skip OFFSET bytes

hostid
    hostid

    Print out a unique 32-bit identifier for the machine

hostname
    hostname [OPTIONS] [HOSTNAME | -F FILE]

    Get or set hostname or DNS domain name

            -s      Short
            -i      Addresses for the hostname
            -d      DNS domain name
            -f      Fully qualified domain name
            -F FILE Use FILE's content as hostname

httpd
    httpd [-ifv[v]] [-c CONFFILE] [-p [IP:]PORT] [-u USER[:GRP]] [-r REALM] [-h HOME] or httpd -d/-e/-m STRING

    Listen for incoming HTTP requests

            -i              Inetd mode
            -f              Don't daemonize
            -v[v]           Verbose
            -p [IP:]PORT    Bind to IP:PORT (default *:80)
            -u USER[:GRP]   Set uid/gid after binding to port
            -r REALM        Authentication Realm for Basic Authentication
            -h HOME         Home directory (default .)
            -c FILE         Configuration file (default {/etc,HOME}/httpd.conf)
            -m STRING       MD5 crypt STRING
            -e STRING       HTML encode STRING
            -d STRING       URL decode STRING

hwclock
    hwclock [-r|--show] [-s|--hctosys] [-w|--systohc] [--systz] [--localtime] [-u|--utc] [-f|--rtc FILE]

    Query and set hardware clock (RTC)

            -r      Show hardware clock time
            -s      Set system time from hardware clock
            -w      Set hardware clock from system time
            --systz Set in-kernel timezone, correct system time
                    if hardware clock is in local time
            -u      Assume hardware clock is kept in UTC
            --localtime     Assume hardware clock is kept in local time
            -f FILE Use specified device (e.g. /dev/rtc2)

i2cdetect
    i2cdetect -l | -F I2CBUS | [-ya] [-q|-r] I2CBUS [FIRST LAST]

    Detect I2C chips

            -l      List installed buses
            -F BUS# List functionalities on this bus
            -y      Disable interactive mode
            -a      Force scanning of non-regular addresses
            -q      Use smbus quick write commands for probing (default)
            -r      Use smbus read byte commands for probing
            FIRST and LAST limit probing range

i2cdump
    i2cdump [-fy] [-r FIRST-LAST] BUS ADDR [MODE]

    Examine I2C registers

            I2CBUS  I2C bus number
            ADDRESS 0x03-0x77
    MODE is:

            b       Byte (default)
            w       Word
            W       Word on even register addresses
            i       I2C block
            s       SMBus block
            c       Consecutive byte
            Append p for SMBus PEC

            -f      Force access
            -y      Disable interactive mode
            -r      Limit the number of registers being accessed

i2cget
    i2cget [-fy] BUS CHIP-ADDRESS [DATA-ADDRESS [MODE]]

    Read from I2C/SMBus chip registers

            I2CBUS  I2C bus number
            ADDRESS 0x03-0x77
    MODE is:

            b       Read byte data (default)
            w       Read word data
            c       Write byte/read byte
            Append p for SMBus PEC

            -f      Force access
            -y      Disable interactive mode

i2cset
    i2cset [-fy] [-m MASK] BUS CHIP-ADDRESS DATA-ADDRESS [VALUE] ... [MODE]

    Set I2C registers

            I2CBUS  I2C bus number
            ADDRESS 0x03-0x77
    MODE is:

            c       Byte, no value
            b       Byte data (default)
            w       Word data
            i       I2C block data
            s       SMBus block data
            Append p for SMBus PEC

            -f      Force access
            -y      Disable interactive mode
            -r      Read back and compare the result
            -m MASK Mask specifying which bits to write

id  id [OPTIONS] [USER]

    Print information about USER or the current user

            -u      User ID
            -g      Group ID
            -G      Supplementary group IDs
            -n      Print names instead of numbers
            -r      Print real ID instead of effective ID

ifconfig
    ifconfig [-a] interface [address]

    Configure a network interface

            [add ADDRESS[/PREFIXLEN]]
            [del ADDRESS[/PREFIXLEN]]
            [[-]broadcast [ADDRESS]] [[-]pointopoint [ADDRESS]]
            [netmask ADDRESS] [dstaddr ADDRESS]
            [outfill NN] [keepalive NN]
            [hw ether|infiniband ADDRESS] [metric NN] [mtu NN]
            [[-]trailers] [[-]arp] [[-]allmulti]
            [multicast] [[-]promisc] [txqueuelen NN] [[-]dynamic]
            [mem_start NN] [io_addr NN] [irq NN]
            [up|down] ...

ifdown
    ifdown [-anvf] [-i FILE] IFACE...

            -a      Deconfigure all interfaces
            -i FILE Use FILE for interface definitions
            -n      Print out what would happen, but don't do it
            -v      Print out what would happen before doing it
            -f      Force deconfiguration

ifup
    ifup [-anvf] [-i FILE] IFACE...

            -a      Configure all interfaces
            -i FILE Use FILE instead of /etc/network/interfaces
            -n      Print out what would happen, but don't do it
            -v      Print out what would happen before doing it
            -f      Force configuration

init
    init

    Init is the first process started during boot. It never exits. It (re)spawns children according to /etc/inittab.

insmod
    insmod FILE [SYMBOL=VALUE]...

    Load kernel module

ionice
    ionice [-c 1-3] [-n 0-7] [-p PID] [PROG]

    Change I/O priority and class

            -c      Class. 1:realtime 2:best-effort 3:idle
            -n      Priority

ip  ip [OPTIONS] address|route|link|tunnel|neigh|rule [ARGS]

    OPTIONS := -f[amily] inet|inet6|link | -o[neline]

    ip addr add|del IFADDR dev IFACE | show|flush [dev IFACE] [to PREFIX] ip route list|flush|add|del|change|append|replace|test ROUTE ip link set IFACE [up|down] [arp on|off] [multicast on|off]
        [promisc on|off] [mtu NUM] [name NAME] [qlen NUM] [address MAC]
        [master IFACE | nomaster] ip tunnel add|change|del|show [NAME]
        [mode ipip|gre|sit] [remote ADDR] [local ADDR] [ttl TTL] ip neigh show|flush [to PREFIX] [dev DEV] [nud STATE] ip rule [list] | add|del SELECTOR ACTION

ipcalc
    ipcalc [OPTIONS] ADDRESS[/PREFIX] [NETMASK]

    Calculate and display network settings from IP address

            -b      Broadcast address
            -n      Network address
            -m      Default netmask for IP
            -p      Prefix for IP/NETMASK
            -h      Resolved host name
            -s      No error messages

ipneigh
    ipneigh show|flush [to PREFIX] [dev DEV] [nud STATE]

kill
    kill [-l] [-SIG] PID...

    Send a signal (default: TERM) to given PIDs

            -l      List all signal names and numbers

killall
    killall [-l] [-q] [-SIG] PROCESS_NAME...

    Send a signal (default: TERM) to given processes

            -l      List all signal names and numbers
            -q      Don't complain if no processes were killed

klogd
    klogd [-c N] [-n]

    Log kernel messages to syslog

            -c N    Print to console messages more urgent than prio N (1-8)
            -n      Run in foreground

last
    last

    Show listing of the last users that logged into the system

less
    less [-EFIMmNSRh~] [FILE]...

    View FILE (or stdin) one screenful at a time

            -E      Quit once the end of a file is reached
            -F      Quit if entire file fits on first screen
            -I      Ignore case in all searches
            -M,-m   Display status line with line numbers
                    and percentage through the file
            -N      Prefix line number to each line
            -S      Truncate long lines
            -R      Remove color escape codes in input
            -~      Suppress ~s displayed past EOF

link
    link FILE LINK

    Create hard LINK to FILE

ln  ln [OPTIONS] TARGET... LINK|DIR

    Create a link LINK or DIR/TARGET to the specified TARGET(s)

            -s      Make symlinks instead of hardlinks
            -f      Remove existing destinations
            -n      Don't dereference symlinks - treat like normal file
            -b      Make a backup of the target (if exists) before link operation
            -S suf  Use suffix instead of ~ when making backup files
            -T      2nd arg must be a DIR
            -v      Verbose

loadfont
    loadfont < font

    Load a console font from stdin

loadkmap
    loadkmap < keymap

    Load a binary keyboard translation table from stdin

logger
    logger [OPTIONS] [MESSAGE]

    Write MESSAGE (or stdin) to syslog

            -s      Log to stderr as well as the system log
            -t TAG  Log using the specified tag (defaults to user name)
            -p PRIO Priority (numeric or facility.level pair)

login
    login [-p] [-h HOST] [[-f] USER]

    Begin a new session on the system

            -f      Don't authenticate (user already authenticated)
            -h HOST Host user came from (for network logins)
            -p      Preserve environment

logname
    logname

    Print the name of the current user

logread
    logread [-fF]

    Show messages in syslogd's circular buffer

            -f      Output data as log grows
            -F      Same as -f, but dump buffer first

losetup
    losetup [-r] [-o OFS] {-f|LOOPDEV} FILE - associate loop devices
        losetup -d LOOPDEV - disassociate
        losetup -a - show status
        losetup -f - show next free loop device

            -o OFS  Start OFS bytes into FILE
            -r      Read-only
            -f      Show/use next free loop device

ls  ls [-1AaCxdLHRFplinshrSXvctu] [-w WIDTH] [FILE]...

    List directory contents

            -1      One column output
            -a      Include entries which start with .
            -A      Like -a, but exclude . and ..
            -x      List by lines
            -d      List directory entries instead of contents
            -L      Follow symlinks
            -H      Follow symlinks on command line
            -R      Recurse
            -p      Append / to dir entries
            -F      Append indicator (one of */=@|) to entries
            -l      Long listing format
            -i      List inode numbers
            -n      List numeric UIDs and GIDs instead of names
            -s      List allocated blocks
            -lc     List ctime
            -lu     List atime
            --full-time     List full date and time
            -h      Human readable sizes (1K 243M 2G)
            --group-directories-first
            -S      Sort by size
            -X      Sort by extension
            -v      Sort by version
            -t      Sort by mtime
            -tc     Sort by ctime
            -tu     Sort by atime
            -r      Reverse sort order
            -w N    Format N columns wide
            --color[={always,never,auto}]   Control coloring

lsmod
    lsmod

    List loaded kernel modules

lzcat
    lzcat [FILE]...

    Decompress to stdout

lzma
    lzma -d [-cfk] [FILE]...

    Decompress FILE (or stdin)

            -d      Decompress
            -c      Write to stdout
            -f      Force
            -k      Keep input files

lzop
    lzop [-cfUvd123456789CF] [FILE]...

            -1..9   Compression level
            -d      Decompress
            -c      Write to stdout
            -f      Force
            -U      Delete input files
            -v      Verbose
            -F      Don't store or verify checksum
            -C      Also write checksum of compressed block

md5sum
    md5sum [-c[sw]] [FILE]...

    Print or check MD5 checksums

            -c      Check sums against list in FILEs
            -s      Don't output anything, status code shows success
            -w      Warn about improperly formatted checksum lines

mdev
    mdev [-s]

    mdev -s is to be run during boot to scan /sys and populate /dev.

    Bare mdev is a kernel hotplug helper. To activate it:
        echo /sbin/mdev >/proc/sys/kernel/hotplug

    It uses /etc/mdev.conf with lines
        [-][ENV=regex;]...DEVNAME UID:GID PERM [>|=PATH]|[!] [@|$|*PROG] where DEVNAME is device name regex, @major,minor[-minor2], or environment variable regex. A common use of the latter is to load modules for hotplugged devices:

            $MODALIAS=.* 0:0 660 @modprobe "$MODALIAS"

    If /dev/mdev.seq file exists, mdev will wait for its value to match $SEQNUM variable. This prevents plug/unplug races. To activate this feature, create empty /dev/mdev.seq at boot.

    If /dev/mdev.log file exists, debug log will be appended to it.

microcom
    microcom [-d DELAY] [-t TIMEOUT] [-s SPEED] [-X] TTY

    Copy bytes for stdin to TTY and from TTY to stdout

            -d      Wait up to DELAY ms for TTY output before sending every
                    next byte to it
            -t      Exit if both stdin and TTY are silent for TIMEOUT ms
            -s      Set serial line to SPEED
            -X      Disable special meaning of NUL and Ctrl-X from stdin

mkdir
    mkdir [OPTIONS] DIRECTORY...

    Create DIRECTORY

            -m MODE Mode
            -p      No error if exists; make parent directories as needed

mkdosfs
    mkdosfs [-v] [-n LABEL] BLOCKDEV [KBYTES]

    Make a FAT32 filesystem

            -v      Verbose
            -n LBL  Volume label

mke2fs
    mke2fs [-Fn] [-b BLK_SIZE] [-i INODE_RATIO] [-I INODE_SIZE] [-m RESERVED_PERCENT] [-L LABEL] BLOCKDEV [KBYTES]

            -b BLK_SIZE     Block size, bytes
            -F              Force
            -i RATIO        Max number of files is filesystem_size / RATIO
            -I BYTES        Inode size (min 128)
            -L LBL          Volume label
            -m PERCENT      Percent of blocks to reserve for admin
            -n              Dry run

mkfifo
    mkfifo [-m MODE] NAME

    Create named pipe

            -m MODE Mode (default a=rw)

mknod
    mknod [-m MODE] NAME TYPE [MAJOR MINOR]

    Create a special file (block, character, or pipe)

            -m MODE Creation mode (default a=rw)
    TYPE:
            b       Block device
            c or u  Character device
            p       Named pipe (MAJOR MINOR must be omitted)

mkpasswd
    mkpasswd [OPTIONS] [PASSWORD] [SALT]

    Print crypt(3) hashed PASSWORD

            -P,--password-fd N      Read password from fd N
            -m,--method TYPE        des,md5,sha256/512 (default )
            -S,--salt SALT

mkswap
    mkswap [-L LBL] BLOCKDEV [KBYTES]

    Prepare BLOCKDEV to be used as swap partition

            -L LBL  Label

mktemp
    mktemp [-dt] [-p DIR] [TEMPLATE]

    Create a temporary file with name based on TEMPLATE and print its name. TEMPLATE must end with XXXXXX (e.g. [/dir/]nameXXXXXX). Without TEMPLATE, -t tmp.XXXXXX is assumed.

            -d      Make directory, not file
            -q      Fail silently on errors
            -t      Prepend base directory name to TEMPLATE
            -p DIR  Use DIR as a base directory (implies -t)
            -u      Do not create anything; print a name

    Base directory is: -p DIR, else $TMPDIR, else /tmp

modinfo
    modinfo [-adlpn0] [-F keyword] MODULE

            -a              Shortcut for '-F author'
            -d              Shortcut for '-F description'
            -l              Shortcut for '-F license'
            -p              Shortcut for '-F parm'
            -F keyword      Keyword to look for
            -0              Separate output with NULs

modprobe
    modprobe [-alrqvsDb] MODULE [SYMBOL=VALUE]...

            -a      Load multiple MODULEs
            -l      List (MODULE is a pattern)
            -r      Remove MODULE (stacks) or do autoclean
            -q      Quiet
            -v      Verbose
            -s      Log to syslog
            -D      Show dependencies
            -b      Apply blacklist to module names too

more
    more [FILE]...

    View FILE (or stdin) one screenful at a time

mount
    mount [OPTIONS] [-o OPT] DEVICE NODE

    Mount a filesystem. Filesystem autodetection requires /proc.

            -a              Mount all filesystems in fstab
            -f              Dry run
            -i              Don't run mount helper
            -r              Read-only mount
            -t FSTYPE[,...] Filesystem type(s)
            -T FILE         Read FILE instead of /etc/fstab
            -O OPT          Mount only filesystems with option OPT (-a only)
    -o OPT:
            loop            Ignored (loop devices are autodetected)
            [a]sync         Writes are [a]synchronous
            [no]atime       Disable/enable updates to inode access times
            [no]diratime    Disable/enable atime updates to directories
            [no]relatime    Disable/enable atime updates relative to modification time
            [no]dev         (Dis)allow use of special device files
            [no]exec        (Dis)allow use of executable files
            [no]suid        (Dis)allow set-user-id-root programs
            [r]shared       Convert [recursively] to a shared subtree
            [r]slave        Convert [recursively] to a slave subtree
            [r]private      Convert [recursively] to a private subtree
            [un]bindable    Make mount point [un]able to be bind mounted
            [r]bind         Bind a file or directory [recursively] to another location
            move            Relocate an existing mount point
            remount         Remount a mounted filesystem, changing flags
            ro              Same as -r

    There are filesystem-specific -o flags.

mt  mt [-f device] opcode value

    Control magnetic tape drive operation

    Available Opcodes:

    bsf bsfm bsr bss datacompression drvbuffer eof eom erase fsf fsfm fsr fss load lock mkpart nop offline ras1 ras2 ras3 reset retension rewind rewoffline seek setblk setdensity setpart tell unload unlock weof wset

mv  mv [-fin] SOURCE DEST or: mv [-fin] SOURCE... DIRECTORY

    Rename SOURCE to DEST, or move SOURCE(s) to DIRECTORY

            -f      Don't prompt before overwriting
            -i      Interactive, prompt before overwrite
            -n      Don't overwrite an existing file

nameif
    nameif [-s] [-c FILE] [IFNAME HWADDR]...

    Rename network interface while it in the down state. The device with address HWADDR is renamed to IFACE.

            -c FILE Configuration file (default: /etc/mactab)
            -s      Log to syslog

nc  nc [-iN] [-wN] [-l] [-p PORT] [-f FILE|IPADDR PORT] [-e PROG]

    Open a pipe to IP:PORT or FILE

            -l      Listen mode, for inbound connects
                    (use -ll with -e for persistent server)
            -p PORT Local port
            -w SEC  Connect timeout
            -i SEC  Delay interval for lines sent
            -f FILE Use file (ala /dev/ttyS0) instead of network
            -e PROG Run PROG after connect

netstat
    netstat [-ral] [-tuwx] [-en]

    Display networking information

            -r      Routing table
            -a      All sockets
            -l      Listening sockets
                    Else: connected sockets
            -t      TCP sockets
            -u      UDP sockets
            -w      Raw sockets
            -x      Unix sockets
                    Else: all socket types
            -e      Other/more information
            -n      Don't resolve names

nl  nl [OPTIONS] [FILE]...

    Write FILEs to standard output with line numbers added

            -b STYLE        Which lines to number - a: all, t: nonempty, n: none
            -i N            Line number increment
            -s STRING       Use STRING as line number separator
            -v N            Start from N
            -w N            Width of line numbers

nologin
    nologin

    Politely refuse a login

nproc
    nproc --all --ignore=N

    Print number of available CPUs

            --all           Number of installed CPUs
            --ignore=N      Exclude N CPUs

nsenter
    nsenter [OPTIONS] [PROG [ARGS]]

            -t PID          Target process to get namespaces from
            -m[FILE]        Enter mount namespace
            -u[FILE]        Enter UTS namespace (hostname etc)
            -i[FILE]        Enter System V IPC namespace
            -n[FILE]        Enter network namespace
            -p[FILE]        Enter pid namespace
            -U[FILE]        Enter user namespace
            -S UID          Set uid in entered namespace
            -G GID          Set gid in entered namespace
            --preserve-credentials  Don't touch uids or gids
            -r[DIR]         Set root directory
            -w[DIR]         Set working directory
            -F              Don't fork before exec'ing PROG

nslookup
    nslookup [-type=QUERY_TYPE] [-debug] HOST [DNS_SERVER]

    Query DNS about HOST

    QUERY_TYPE: soa,ns,a,aaaa,cname,mx,txt,ptr,any

nuke
    nuke DIR...

    Remove DIRs

od  od [-abcdfhilovxs] [-t TYPE] [-A RADIX] [-N SIZE] [-j SKIP] [-S MINSTR] [-w WIDTH] [FILE]...

    Print FILEs (or stdin) unambiguously, as octal bytes by default

openvt
    openvt [-c N] [-sw] [PROG ARGS]

    Start PROG on a new virtual terminal

            -c N    Use specified VT
            -s      Switch to the VT
            -w      Wait for PROG to exit

partprobe
    partprobe DEVICE...

    Ask kernel to rescan partition table

paste
    paste [OPTIONS] [FILE]...

    Paste lines from each input file, separated with tab

            -d LIST Use delimiters from LIST, not tab
            -s      Serial: one file at a time

patch
    patch [OPTIONS] [ORIGFILE [PATCHFILE]]

            -p N    Strip N leading components from file names
            -i DIFF Read DIFF instead of stdin
            -R      Reverse patch
            -N      Ignore already applied patches
            -E      Remove output files if they become empty
            --dry-run       Don't actually change files

pidof
    pidof [NAME]...

    List PIDs of all processes with names that match NAMEs

ping
    ping [OPTIONS] HOST

    Send ICMP ECHO_REQUEST packets to network hosts

            -4,-6           Force IP or IPv6 name resolution
            -c CNT          Send only CNT pings
            -s SIZE         Send SIZE data bytes in packets (default 56)
            -i SECS         Interval
            -A              Ping as soon as reply is recevied
            -t TTL          Set TTL
            -I IFACE/IP     Source interface or IP address
            -W SEC          Seconds to wait for the first response (default 10)
                            (after all -c CNT packets are sent)
            -w SEC          Seconds until ping exits (default:infinite)
                            (can exit earlier with -c CNT)
            -q              Quiet, only display output at start
                            and when finished
            -p HEXBYTE      Pattern to use for payload

ping6
    ping6 [OPTIONS] HOST

    Send ICMP ECHO_REQUEST packets to network hosts

            -c CNT          Send only CNT pings
            -s SIZE         Send SIZE data bytes in packets (default 56)
            -i SECS         Interval
            -A              Ping as soon as reply is recevied
            -I IFACE/IP     Source interface or IP address
            -q              Quiet, only display output at start
                            and when finished
            -p HEXBYTE      Pattern to use for payload

pivot_root
    pivot_root NEW_ROOT PUT_OLD

    Move the current root file system to PUT_OLD and make NEW_ROOT the new root file system

poweroff
    poweroff [-d DELAY] [-n] [-f]

    Halt and shut off power

            -d SEC  Delay interval
            -n      Do not sync
            -f      Force (don't go through init)

printf
    printf FORMAT [ARG]...

    Format and print ARG(s) according to FORMAT (a-la C printf)

ps  ps [-o COL1,COL2=HEADER] [-T]

    Show list of processes

            -o COL1,COL2=HEADER     Select columns for display
            -T                      Show threads

pwd pwd

    Print the full filename of the current working directory

rdate
    rdate [-s/-p] HOST

    Set and print time from HOST using RFC 868

            -s      Only set system time
            -p      Only print time

readlink
    readlink [-fnv] FILE

    Display the value of a symlink

            -f      Canonicalize by following all symlinks
            -n      Don't add newline
            -v      Verbose

realpath
    realpath FILE...

    Return the absolute pathnames of given FILE

reboot
    reboot [-d DELAY] [-n] [-f]

    Reboot the system

            -d SEC  Delay interval
            -n      Do not sync
            -f      Force (don't go through init)

renice
    renice [-n] PRIORITY [[-p | -g | -u] ID...]...

    Change scheduling priority of a running process

            -n      Add PRIORITY to current nice value
                    Without -n, nice value is set to PRIORITY
            -p      Process ids (default)
            -g      Process group ids
            -u      Process user names

reset
    reset

    Reset the screen

resume
    resume BLOCKDEV [OFFSET]

    Restore system state from 'suspend-to-disk' data in BLOCKDEV

rev rev [FILE]...

    Reverse lines of FILE

rm  rm [-irf] FILE...

    Remove (unlink) FILEs

            -i      Always prompt before removing
            -f      Never prompt
            -R,-r   Recurse

rmdir
    rmdir [OPTIONS] DIRECTORY...

    Remove DIRECTORY if it is empty

            -p      Include parents
            --ignore-fail-on-non-empty

rmmod
    rmmod [-wfa] [MODULE]...

    Unload kernel modules

            -w      Wait until the module is no longer used
            -f      Force unload
            -a      Remove all unused modules (recursively)

route
    route [{add|del|delete}]

    Edit kernel routing tables

            -n      Don't resolve names
            -e      Display other/more information
            -A inet{6}      Select address family

rpm rpm -i PACKAGE.rpm; rpm -qp[ildc] PACKAGE.rpm

    Manipulate RPM packages

    Commands:

            -i      Install package
            -qp     Query package
            -qpi    Show information
            -qpl    List contents
            -qpd    List documents
            -qpc    List config files

rpm2cpio
    rpm2cpio PACKAGE.rpm

    Output a cpio archive of the rpm file

run-init
    run-init [-d CAP,CAP...] [-n] [-c CONSOLE_DEV] NEW_ROOT NEW_INIT [ARGS]

    Free initramfs and switch to another root fs:

    chroot to NEW_ROOT, delete all in /, move NEW_ROOT to /, execute NEW_INIT. PID must be 1. NEW_ROOT must be a mountpoint.

            -c DEV  Reopen stdio to DEV after switch
            -d CAPS Drop capabilities
            -n      Dry run

run-parts
    run-parts [-a ARG]... [-u UMASK] [--reverse] [--test] [--exit-on-error] DIRECTORY

    Run a bunch of scripts in DIRECTORY

            -a ARG          Pass ARG as argument to scripts
            -u UMASK        Set UMASK before running scripts
            --reverse       Reverse execution order
            --test          Dry run
            --exit-on-error Exit if a script exits with non-zero

sed sed [-i[SFX]] [-nrE] [-f FILE]... [-e CMD]... [FILE]... or: sed [-i[SFX]] [-nrE] CMD [FILE]...

            -e CMD  Add CMD to sed commands to be executed
            -f FILE Add FILE contents to sed commands to be executed
            -i[SFX] Edit files in-place (otherwise sends to stdout)
                    Optionally back files up, appending SFX
            -n      Suppress automatic printing of pattern space
            -r,-E   Use extended regex syntax

    If no -e or -f, the first non-option argument is the sed command string. Remaining arguments are input files (stdin if none).

seq seq [-w] [-s SEP] [FIRST [INC]] LAST

    Print numbers from FIRST to LAST, in steps of INC. FIRST, INC default to 1.

            -w      Pad to last with leading zeros
            -s SEP  String separator

setkeycodes
    setkeycodes { SCANCODE KEYCODE }...

    Modify kernel's scancode-to-keycode map, allowing unusual keyboards to generate usable keycodes.

    SCANCODE is either xx or e0xx (hexadecimal), KEYCODE is decimal.

setpriv
    setpriv [OPTIONS] PROG [ARGS]

    Run PROG with different privilege settings

    -d,--dump    Show current capabilities
    --nnp,--no-new-privs    Ignore setuid/setgid bits and file capabilities
    --inh-caps CAP,CAP    Set inheritable capabilities
    --ambient-caps CAP,CAP    Set ambient capabilities

setsid
    setsid [-c] PROG ARGS

    Run PROG in a new session. PROG will have no controlling terminal and will not be affected by keyboard signals (^C etc).

            -c      Set controlling terminal to stdin

sh  sh [-/+OPTIONS] [-/+o OPT]... [-c 'SCRIPT' [ARG0 [ARGS]] / FILE [ARGS] / -s [ARGS]]

    Unix shell interpreter

sha1sum
    sha1sum [-c[sw]] [FILE]...

    Print or check SHA1 checksums

            -c      Check sums against list in FILEs
            -s      Don't output anything, status code shows success
            -w      Warn about improperly formatted checksum lines

sha256sum
    sha256sum [-c[sw]] [FILE]...

    Print or check SHA256 checksums

            -c      Check sums against list in FILEs
            -s      Don't output anything, status code shows success
            -w      Warn about improperly formatted checksum lines

sha512sum
    sha512sum [-c[sw]] [FILE]...

    Print or check SHA512 checksums

            -c      Check sums against list in FILEs
            -s      Don't output anything, status code shows success
            -w      Warn about improperly formatted checksum lines

shred
    shred FILE...

    Overwrite/delete FILEs

            -f      Chmod to ensure writability
            -n N    Overwrite N times (default 3)
            -z      Final overwrite with zeros
            -u      Remove file

shuf
    shuf [-e|-i L-H] [-n NUM] [-o FILE] [-z] [FILE|ARG...]

    Randomly permute lines

            -e      Treat ARGs as lines
            -i L-H  Treat numbers L-H as lines
            -n NUM  Output at most NUM lines
            -o FILE Write to FILE, not standard output
            -z      End lines with zero byte, not newline

sleep
    sleep [N]...

    Pause for a time equal to the total of the args given, where each arg can have an optional suffix of (s)econds, (m)inutes, (h)ours, or (d)ays

sort
    sort [-nrugMcszbdfiokt] [-o FILE] [-k start[.offset][opts][,end[.offset][opts]] [-t CHAR] [FILE]...

    Sort lines of text

            -o FILE Output to FILE
            -c      Check whether input is sorted
            -b      Ignore leading blanks
            -f      Ignore case
            -i      Ignore unprintable characters
            -d      Dictionary order (blank or alphanumeric only)
            -n      Sort numbers
            -g      General numerical sort
            -M      Sort month
            -V      Sort version
            -t CHAR Field separator
            -k N[,M] Sort by Nth field
            -r      Reverse sort order
            -s      Stable (don't sort ties alphabetically)
            -u      Suppress duplicate lines
            -z      Lines are terminated by NUL, not newline

ssl_client
    ssl_client [-e] -s FD [-r FD] [-n SNI]

start-stop-daemon
    start-stop-daemon [OPTIONS] [-S|-K] ... [-- ARGS...]

    Search for matching processes, and then -K: stop all matching processes -S: start a process unless a matching process is found

    Process matching:

            -u USERNAME|UID Match only this user's processes
            -n NAME         Match processes with NAME
                            in comm field in /proc/PID/stat
            -x EXECUTABLE   Match processes with this command
                            command in /proc/PID/cmdline
            -p FILE         Match a process with PID from FILE
            All specified conditions must match
    -S only:
            -x EXECUTABLE   Program to run
            -a NAME         Zeroth argument
            -b              Background
            -N N            Change nice level
            -c USER[:[GRP]] Change user/group
            -m              Write PID to pidfile specified by -p
    -K only:
            -s SIG          Signal to send
            -t              Match only, exit with 0 if found
    Other:

            -o              Exit with status 0 if nothing is done
            -v              Verbose
            -q              Quiet

stat
    stat [OPTIONS] FILE...

    Display file (default) or filesystem status

            -c FMT  Use the specified format
            -f      Display filesystem status
            -L      Follow links
            -t      Terse display

    FMT sequences for files:

     %a     Access rights in octal
     %A     Access rights in human readable form
     %b     Number of blocks allocated (see %B)
     %B     Size in bytes of each block reported by %b
     %d     Device number in decimal
     %D     Device number in hex
     %f     Raw mode in hex
     %F     File type
     %g     Group ID
     %G     Group name
     %h     Number of hard links
     %i     Inode number
     %n     File name
     %N     File name, with -> TARGET if symlink
     %o     I/O block size
     %s     Total size in bytes
     %t     Major device type in hex
     %T     Minor device type in hex
     %u     User ID
     %U     User name
     %x     Time of last access
     %X     Time of last access as seconds since Epoch
     %y     Time of last modification
     %Y     Time of last modification as seconds since Epoch
     %z     Time of last change
     %Z     Time of last change as seconds since Epoch

    FMT sequences for file systems:

     %a     Free blocks available to non-superuser
     %b     Total data blocks
     %c     Total file nodes
     %d     Free file nodes
     %f     Free blocks
     %i     File System ID in hex
     %l     Maximum length of filenames
     %n     File name
     %s     Block size (for faster transfer)
     %S     Fundamental block size (for block counts)
     %t     Type in hex
     %T     Type in human readable form

strings
    strings [-fo] [-t o/d/x] [-n LEN] [FILE]...

    Display printable strings in a binary file

            -f              Precede strings with filenames
            -o              Precede strings with octal offsets
            -t o/d/x        Precede strings with offsets in base 8/10/16
            -n LEN          At least LEN characters form a string (default 4)

stty
    stty [-a|g] [-F DEVICE] [SETTING]...

    Without arguments, prints baud rate, line discipline, and deviations from stty sane

            -F DEVICE       Open device instead of stdin
            -a              Print all current settings in human-readable form
            -g              Print in stty-readable form
            [SETTING]       See manpage

svc svc [-udopchaitkx] SERVICE_DIR...

    Control services monitored by runsv supervisor

            -u      If service is not running, start it; restart if it stops
            -d      If service is running, send TERM+CONT signals; do not restart it
            -o      Once: if service is not running, start it; do not restart it
            -pchaitk Send STOP, CONT, HUP, ALRM, INT, TERM, KILL signal to service
            -x      Exit: runsv will exit as soon as the service is down

svok
    svok SERVICE_DIR

    Check whether runsv supervisor is running. Exit code is 0 if it does, 100 if it does not, 111 (with error message) if SERVICE_DIR does not exist.

swapoff
    swapoff [-a] [DEVICE]

    Stop swapping on DEVICE

            -a      Stop swapping on all swap devices

swapon
    swapon [-a] [-e] [-d[POL]] [DEVICE]

    Start swapping on DEVICE

            -a      Start swapping on all swap devices
            -d[POL] Discard blocks at swapon (POL=once),
                    as freed (POL=pages), or both (POL omitted)
            -e      Silently skip devices that do not exist

switch_root
    switch_root [-c CONSOLE_DEV] NEW_ROOT NEW_INIT [ARGS]

    Free initramfs and switch to another root fs:

    chroot to NEW_ROOT, delete all in /, move NEW_ROOT to /, execute NEW_INIT. PID must be 1. NEW_ROOT must be a mountpoint.

            -c DEV  Reopen stdio to DEV after switch

sync
    sync [-df] [FILE]...

    Write all buffered blocks (in FILEs) to disk
        -d    Avoid syncing metadata
        -f    Sync filesystems underlying FILEs

sysctl
    sysctl -p [-enq] [FILE...] / [-enqaw] [KEY[=VALUE]]...

    Show/set kernel parameters

            -p      Set values from FILEs (default /etc/sysctl.conf)
            -e      Don't warn about unknown keys
            -n      Don't show key names
            -q      Quiet
            -a      Show all values
            -w      Set values

syslogd
    syslogd [OPTIONS]

    System logging utility (this version of syslogd ignores /etc/syslog.conf)

            -n              Run in foreground
            -R HOST[:PORT]  Log to HOST:PORT (default PORT:514)
            -L              Log locally and via network (default is network only if -R)
            -C[size_kb]     Log to shared mem buffer (use logread to read it)
            -O FILE         Log to FILE (default: /var/log/messages, stdout if -)
            -l N            Log only messages more urgent than prio N (1-8)
            -S              Smaller output
            -t              Strip client-generated timestamps

tac tac [FILE]...

    Concatenate FILEs and print them in reverse

tail
    tail [OPTIONS] [FILE]...

    Print last 10 lines of each FILE (or stdin) to stdout. With more than one FILE, precede each with a filename header.

            -f              Print data as file grows
            -c [+]N[kbm]    Print last N bytes
            -n N[kbm]       Print last N lines
            -n +N[kbm]      Start on Nth line and print the rest
            -q              Never print headers
            -s SECONDS      Wait SECONDS between reads with -f
            -v              Always print headers
            -F              Same as -f, but keep retrying

    N may be suffixed by k (x1024), b (x512), or m (x1024^2).

tar tar c|x|t [-ZzJjahmvokO] [-f TARFILE] [-C DIR] [FILE]...

    Create, extract, or list files from a tar file

            c       Create
            x       Extract
            t       List
            -f FILE Name of TARFILE ('-' for stdin/out)
            -C DIR  Change to DIR before operation
            -v      Verbose
            -O      Extract to stdout
            -m      Don't restore mtime
            -o      Don't restore user:group
            -k      Don't replace existing files
            -Z      (De)compress using compress
            -z      (De)compress using gzip
            -J      (De)compress using xz
            -j      (De)compress using bzip2
            -a      (De)compress using lzma
            -h      Follow symlinks

taskset
    taskset [-p] [HEXMASK] PID | PROG ARGS

    Set or get CPU affinity

            -p      Operate on an existing PID

tee tee [-ai] [FILE]...

    Copy stdin to each FILE, and also to stdout

            -a      Append to the given FILEs, don't overwrite
            -i      Ignore interrupt signals (SIGINT)

telnet
    telnet [-a] [-l USER] HOST [PORT]

    Connect to telnet server

            -a      Automatic login with $USER variable
            -l USER Automatic login as USER

tftp
    tftp [OPTIONS] HOST [PORT]

    Transfer a file from/to tftp server

            -l FILE Local FILE
            -r FILE Remote FILE
            -g      Get file
            -p      Put file
            -b SIZE Transfer blocks of SIZE octets

time
    time [-vpa] [-o FILE] PROG ARGS

    Run PROG, display resource usage when it exits

            -v      Verbose
            -p      POSIX output format
            -f FMT  Custom format
            -o FILE Write result to FILE
            -a      Append (else overwrite)

timeout
    timeout [-s SIG] SECS PROG ARGS

    Runs PROG. Sends SIG to it if it is not gone in SECS seconds. Default SIG: TERM.

top top [-b] [-nCOUNT] [-dSECONDS]

    Provide a view of process activity in real time. Read the status of all processes from /proc each SECONDS and display a screenful of them. Keys:

            N/M/P/T: sort by pid/mem/cpu/time
            R: reverse sort
            H: toggle threads
            Q,^C: exit

    Options:

            -b      Batch mode
            -n N    Exit after N iterations
            -d N    Delay between updates

touch
    touch [-c] [-d DATE] [-t DATE] [-r FILE] FILE...

    Update the last-modified date on the given FILE[s]

            -c      Don't create files
            -h      Don't follow links
            -d DT   Date/time to use
            -t DT   Date/time to use
            -r FILE Use FILE's date/time

tr  tr [-cds] STRING1 [STRING2]

    Translate, squeeze, or delete characters from stdin, writing to stdout

            -c      Take complement of STRING1
            -d      Delete input characters coded STRING1
            -s      Squeeze multiple output characters of STRING2 into one character

traceroute
    traceroute [-46FIlnrv] [-f 1ST_TTL] [-m MAXTTL] [-q PROBES] [-p PORT]
        [-t TOS] [-w WAIT_SEC] [-s SRC_IP] [-i IFACE]
        [-z PAUSE_MSEC] HOST [BYTES]

    Trace the route to HOST

            -4,-6   Force IP or IPv6 name resolution
            -F      Set don't fragment bit
            -l      Display TTL value of the returned packet
            -n      Print numeric addresses
            -r      Bypass routing tables, send directly to HOST
            -v      Verbose
            -f N    First number of hops (default 1)
            -m N    Max number of hops
            -q N    Number of probes per hop (default 3)
            -p N    Base UDP port number used in probes
                    (default 33434)
            -s IP   Source address
            -i IFACE Source interface
            -t N    Type-of-service in probe packets (default 0)
            -w SEC  Time to wait for a response (default 3)
            -g IP   Loose source route gateway (8 max)

traceroute6
    traceroute6 [-nrv] [-m MAXTTL] [-q PROBES] [-p PORT]
        [-t TOS] [-w WAIT_SEC] [-s SRC_IP] [-i IFACE]
        HOST [BYTES]

    Trace the route to HOST

            -n      Print numeric addresses
            -r      Bypass routing tables, send directly to HOST
            -v      Verbose
            -m N    Max number of hops
            -q N    Number of probes per hop (default 3)
            -p N    Base UDP port number used in probes
                    (default 33434)
            -s IP   Source address
            -i IFACE Source interface
            -t N    Type-of-service in probe packets (default 0)
            -w SEC  Time wait for a response (default 3)

truncate
    truncate [-c] -s SIZE FILE...

    Truncate FILEs to the given size

            -c      Do not create files
            -s SIZE Truncate to SIZE

tty tty

    Print file name of stdin's terminal

            -s      Print nothing, only return exit status

ubirename
    ubirename UBI_DEVICE OLD_VOLNAME NEW_VOLNAME [OLD2 NEW2]...

    Rename UBI volumes on UBI_DEVICE

udhcpc
    udhcpc [-fbqRB] [-a[MSEC]] [-t N] [-T SEC] [-A SEC/-n]
        [-i IFACE] [-s PROG] [-p PIDFILE]
        [-oC] [-r IP] [-V VENDOR] [-F NAME] [-x OPT:VAL]... [-O OPT]...

            -i IFACE        Interface to use (default eth0)
            -s PROG         Run PROG at DHCP events (default /etc/udhcpc/default.script)
            -p FILE         Create pidfile
            -B              Request broadcast replies
            -t N            Send up to N discover packets (default 3)
            -T SEC          Pause between packets (default 3)
            -A SEC          Wait if lease is not obtained (default 20)
            -n              Exit if lease is not obtained
            -q              Exit after obtaining lease
            -R              Release IP on exit
            -f              Run in foreground
            -b              Background if lease is not obtained
            -S              Log to syslog too
            -a[MSEC]        Validate offered address with ARP ping
            -r IP           Request this IP address
            -o              Don't request any options (unless -O is given)
            -O OPT          Request option OPT from server (cumulative)
            -x OPT:VAL      Include option OPT in sent packets (cumulative)
                            Examples of string, numeric, and hex byte opts:
                            -x hostname:bbox - option 12
                            -x lease:3600 - option 51 (lease time)
                            -x 0x3d:0100BEEFC0FFEE - option 61 (client id)
                            -x 14:'"dumpfile"' - option 14 (shell-quoted)
            -F NAME         Ask server to update DNS mapping for NAME
            -V VENDOR       Vendor identifier (default 'udhcp VERSION')
            -C              Don't send MAC as client identifier
    Signals:

            USR1    Renew lease
            USR2    Release lease

udhcpd
    udhcpd [-fS] [-I ADDR] [CONFFILE]

    DHCP server

            -f      Run in foreground
            -S      Log to syslog too
            -I ADDR Local address
            -a MSEC Timeout for ARP ping (default 2000)

uevent
    uevent [PROG [ARGS]]

    uevent runs PROG for every netlink notification. PROG's environment contains data passed from the kernel. Typical usage (daemon for dynamic device node creation):
        # uevent mdev & mdev -s

umount
    umount [OPTIONS] FILESYSTEM|DIRECTORY

    Unmount file systems

            -a      Unmount all file systems
            -r      Try to remount devices as read-only if mount is busy
            -l      Lazy umount (detach filesystem)
            -f      Force umount (i.e., unreachable NFS server)
            -d      Free loop device if it has been used
            -t FSTYPE[,...] Unmount only these filesystem type(s)

uname
    uname [-amnrspvio]

    Print system information

            -a      Print all
            -m      The machine (hardware) type
            -n      Hostname
            -r      Kernel release
            -s      Kernel name (default)
            -p      Processor type
            -v      Kernel version
            -i      The hardware platform
            -o      OS name

uncompress
    uncompress [-cf] [FILE]...

    Decompress .Z file[s]

            -c      Write to stdout
            -f      Overwrite

unexpand
    unexpand [-fa][-t N] [FILE]...

    Convert spaces to tabs, writing to stdout

            -a      Convert all blanks
            -f      Convert only leading blanks
            -t N    Tabstops every N chars

uniq
    uniq [-cdu][-f,s,w N] [INPUT [OUTPUT]]

    Discard duplicate lines

            -c      Prefix lines by the number of occurrences
            -d      Only print duplicate lines
            -u      Only print unique lines
            -i      Ignore case
            -f N    Skip first N fields
            -s N    Skip first N chars (after any skipped fields)
            -w N    Compare N characters in line

unix2dos
    unix2dos [-ud] [FILE]

    Convert FILE in-place from Unix to DOS format. When no file is given, use stdin/stdout.

            -u      dos2unix
            -d      unix2dos

unlink
    unlink FILE

    Delete FILE by calling unlink()

unlzma
    unlzma [-cfk] [FILE]...

    Decompress FILE (or stdin)

            -c      Write to stdout
            -f      Force
            -k      Keep input files

unshare
    unshare [OPTIONS] [PROG [ARGS]]

            -m,--mount[=FILE]       Unshare mount namespace
            -u,--uts[=FILE]         Unshare UTS namespace (hostname etc.)
            -i,--ipc[=FILE]         Unshare System V IPC namespace
            -n,--net[=FILE]         Unshare network namespace
            -p,--pid[=FILE]         Unshare PID namespace
            -U,--user[=FILE]        Unshare user namespace
            -f,--fork               Fork before execing PROG
            -r,--map-root-user      Map current user to root (implies -U)
            --mount-proc[=DIR]      Mount /proc filesystem first (implies -m)
            --propagation slave|shared|private|unchanged
                                    Modify mount propagation in mount namespace
            --setgroups allow|deny  Control the setgroups syscall in user namespaces

unxz
    unxz [-cfk] [FILE]...

    Decompress FILE (or stdin)

            -c      Write to stdout
            -f      Force
            -k      Keep input files

unzip
    unzip [-lnojpq] FILE[.zip] [FILE]... [-x FILE...] [-d DIR]

    Extract FILEs from ZIP archive

            -l      List contents (with -q for short form)
            -n      Never overwrite files (default: ask)
            -o      Overwrite
            -j      Do not restore paths
            -p      Print to stdout
            -q      Quiet
            -x FILE Exclude FILEs
            -d DIR  Extract into DIR

uptime
    uptime

    Display the time since the last boot

usleep
    usleep N

    Pause for N microseconds

uudecode
    uudecode [-o OUTFILE] [INFILE]

    Uudecode a file Finds OUTFILE in uuencoded source unless -o is given

uuencode
    uuencode [-m] [FILE] STORED_FILENAME

    Uuencode FILE (or stdin) to stdout

            -m      Use base64 encoding per RFC1521

vconfig
    vconfig COMMAND [OPTIONS]

    Create and remove virtual ethernet devices

            add             IFACE VLAN_ID
            rem             VLAN_NAME
            set_flag        IFACE 0|1 VLAN_QOS
            set_egress_map  VLAN_NAME SKB_PRIO VLAN_QOS
            set_ingress_map VLAN_NAME SKB_PRIO VLAN_QOS
            set_name_type   NAME_TYPE

vi  vi [OPTIONS] [FILE]...

    Edit FILE

            -c CMD  Initial command to run ($EXINIT also available)
            -R      Read-only
            -H      List available features

w   w

    Show who is logged on

watch
    watch [-n SEC] [-t] PROG ARGS

    Run PROG periodically

            -n      Loop period in seconds (default 2)
            -t      Don't print header

watchdog
    watchdog [-t N[ms]] [-T N[ms]] [-F] DEV

    Periodically write to watchdog device DEV

            -T N    Reboot after N seconds if not reset (default 60)
            -t N    Reset every N seconds (default 30)
            -F      Run in foreground

    Use 500ms to specify period in milliseconds

wc  wc [-cmlwL] [FILE]...

    Count lines, words, and bytes for each FILE (or stdin)

            -c      Count bytes
            -m      Count characters
            -l      Count newlines
            -w      Count words
            -L      Print longest line length

wget
    wget [-c|--continue] [--spider] [-q|--quiet] [-O|--output-document FILE]
        [--header 'header: value'] [-Y|--proxy on/off] [-P DIR]
        [-S|--server-response] [-U|--user-agent AGENT] URL...

    Retrieve files via HTTP or FTP

            --spider        Only check URL existence: $? is 0 if exists
            -c              Continue retrieval of aborted transfer
            -q              Quiet
            -P DIR          Save to DIR (default .)
            -S              Show server response
            -O FILE         Save to FILE ('-' for stdout)
            -U STR          Use STR for User-Agent header
            -Y on/off       Use proxy

which
    which [COMMAND]...

    Locate a COMMAND

who who [-a]

    Show who is logged on

            -a      Show all
            -H      Print column headers

whoami
    whoami

    Print the user name associated with the current effective user id

xargs
    xargs [OPTIONS] [PROG ARGS]

    Run PROG on every item given by stdin

            -p      Ask user whether to run each command
            -r      Don't run command if input is empty
            -0      Input is separated by NULs
            -a FILE Read from FILE instead of stdin
            -t      Print the command on stderr before execution
            -e[STR] STR stops input processing
            -n N    Pass no more than N args to PROG
            -s N    Pass command line of no more than N bytes
            -I STR  Replace STR within PROG ARGS with input line
            -P N    Run up to N PROGs in parallel
            -x      Exit if size is exceeded

xxd xxd [OPTIONS] [FILE]

    Hex dump FILE (or stdin)

            -g N            Bytes per group
            -c N            Bytes per line
            -p              Show only hex bytes, assumes -c30
            -l LENGTH       Show only first LENGTH bytes
            -s OFFSET       Skip OFFSET bytes

xz  xz -d [-cfk] [FILE]...

    Decompress FILE (or stdin)

            -d      Decompress
            -c      Write to stdout
            -f      Force
            -k      Keep input files

xzcat
    xzcat [FILE]...

    Decompress to stdout

yes yes [STRING]

    Repeatedly output a line with STRING, or 'y'

zcat
    zcat [FILE]...

    Decompress to stdout

LIBC NSS
GNU Libc (glibc) uses the Name Service Switch (NSS) to configure the behavior of the C library for the local environment, and to configure how it reads system data, such as passwords and group information. This is implemented using an /etc/nsswitch.conf configuration file, and using one or more of the /lib/libnss_* libraries. BusyBox tries to avoid using any libc calls that make use of NSS. Some applets however, such as login and su, will use libc functions that require NSS.

If you enable CONFIG_USE_BB_PWD_GRP, BusyBox will use internal functions to directly access the /etc/passwd, /etc/group, and /etc/shadow files without using NSS. This may allow you to run your system without the need for installing any of the NSS configuration files and libraries.

When used with glibc, the BusyBox 'networking' applets will similarly require that you install at least some of the glibc NSS stuff (in particular, /etc/nsswitch.conf, /lib/libnss_dns*, /lib/libnss_files*, and /lib/libresolv*).

Shameless Plug: As an alternative, one could use a C library such as uClibc. In addition to making your system significantly smaller, uClibc does not require the use of any NSS support files or libraries.

MAINTAINER
Denis Vlasenko <vda.linux@googlemail.com>

AUTHORS
The following people have contributed code to BusyBox whether they know it or not. If you have written code included in BusyBox, you should probably be listed here so you can obtain your bit of eternal glory. If you should be listed here, or the description of what you have done needs more detail, or is incorrect, please send in an update.

Emanuele Aina <emanuele.aina@tiscali.it>
    run-parts

Erik Andersen <andersen@codepoet.org>

    Tons of new stuff, major rewrite of most of the
    core apps, tons of new apps as noted in header files.
    Lots of tedious effort writing these boring docs that
    nobody is going to actually read.

Laurence Anderson <l.d.anderson@warwick.ac.uk>

    rpm2cpio, unzip, get_header_cpio, read_gz interface, rpm

Jeff Angielski <jeff@theptrgroup.com>

    ftpput, ftpget

Edward Betts <edward@debian.org>

    expr, hostid, logname, whoami

John Beppu <beppu@codepoet.org>

    du, nslookup, sort

Brian Candler <B.Candler@pobox.com>

    tiny-ls(ls)

Randolph Chung <tausq@debian.org>

    fbset, ping, hostname

Dave Cinege <dcinege@psychosis.com>

    more(v2), makedevs, dutmp, modularization, auto links file,
    various fixes, Linux Router Project maintenance

Jordan Crouse <jordan@cosmicpenguin.net>

    ipcalc

Magnus Damm <damm@opensource.se>

    tftp client insmod powerpc support

Larry Doolittle <ldoolitt@recycle.lbl.gov>

    pristine source directory compilation, lots of patches and fixes.

Glenn Engel <glenne@engel.org>

    httpd

Gennady Feldman <gfeldman@gena01.com>

    Sysklogd (single threaded syslogd, IPC Circular buffer support,
    logread), various fixes.

Karl M. Hegbloom <karlheg@debian.org>

    cp_mv.c, the test suite, various fixes to utility.c, &c.

Daniel Jacobowitz <dan@debian.org>

    mktemp.c

Matt Kraai <kraai@alumni.cmu.edu>

    documentation, bugfixes, test suite

Stephan Linz <linz@li-pro.net>

    ipcalc, Red Hat equivalence

John Lombardo <john@deltanet.com>

    tr

Glenn McGrath <bug1@iinet.net.au>

    Common unarchiving code and unarchiving applets, ifupdown, ftpgetput,
    nameif, sed, patch, fold, install, uudecode.
    Various bugfixes, review and apply numerous patches.

Manuel Novoa III <mjn3@codepoet.org>

    cat, head, mkfifo, mknod, rmdir, sleep, tee, tty, uniq, usleep, wc, yes,
    mesg, vconfig, make_directory, parse_mode, dirname, mode_string,
    get_last_path_component, simplify_path, and a number trivial libbb routines

    also bug fixes, partial rewrites, and size optimizations in
    ash, basename, cal, cmp, cp, df, du, echo, env, ln, logname, md5sum, mkdir,
    mv, realpath, rm, sort, tail, touch, uname, watch, arith, human_readable,
    interface, dutmp, ifconfig, route

Vladimir Oleynik <dzo@simtreas.ru>

    cmdedit; xargs(current), httpd(current);
    ports: ash, crond, fdisk, inetd, stty, traceroute, top;
    locale, various fixes
    and irreconcilable critic of everything not perfect.

Bruce Perens <bruce@pixar.com>

    Original author of BusyBox in 1995, 1996. Some of his code can
    still be found hiding here and there...

Tim Riker <Tim@Rikers.org>

    bug fixes, member of fan club

Kent Robotti <robotti@metconnect.com>

    reset, tons and tons of bug reports and patches.

Chip Rosenthal <chip@unicom.com>, <crosenth@covad.com>

    wget - Contributed by permission of Covad Communications

Pavel Roskin <proski@gnu.org>

    Lots of bugs fixes and patches.

Gyepi Sam <gyepi@praxis-sw.com>

    Remote logging feature for syslogd

Linus Torvalds <torvalds@transmeta.com>

    mkswap, fsck.minix, mkfs.minix

Mark Whitley <markw@codepoet.org>

    grep, sed, cut, xargs(previous),
    style-guide, new-applet-HOWTO, bug fixes, etc.

Charles P. Wright <cpwright@villagenet.com>

    gzip, mini-netcat(nc)

Enrique Zanardi <ezanardi@ull.es>

    tarcat (since removed), loadkmap, various fixes, Debian maintenance

Tito Ragusa <farmatito@tiscali.it>

    devfsd and size optimizations in strings, openvt and deallocvt.

Paul Fox <pgf@foxharp.boston.ma.us>

    vi editing mode for ash, various other patches/fixes

Roberto A. Foglietta <me@roberto.foglietta.name>

    port: dnsd

Bernhard Reutner-Fischer <rep.dot.nop@gmail.com>

    misc

Mike Frysinger <vapier@gentoo.org>

    initial e2fsprogs, printenv, setarch, sum, misc

Jie Zhang <jie.zhang@analog.com>

    fixed two bugs in msh and hush (exitcode of killed processes)